(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)





ClearAll[CellularEvolve]

Options[CellularEvolve] =
  {Boundary -> 0,SelfRuled -> None,Blocks -> None,StepFunction -> (#1&),
   MaxIterations -> 30,StopCondition -> Automatic,ShowCondition -> {},
   ShowFunction -> (Show[Cells[#1]]&),ShowOptions -> {},
   ShapeFunction -> Automatic, ColorFunction -> Automatic};

CellularEvolve[st_,rl_,nb_List:{},opts___?OptionQ] :=
  Module[{op = Flatten[{opts,Options[CellularEvolve]}],
          st0 = st1 = st,dim,rules,neighs,bd,sr,self,
          bk,blocks,step,iter = 0,max,stcd,stop = False,rlmod,rlpos,
          nbdim,nbmod,nbpos,bkdim,bkori,bkmod,bkomod,bkpos,bkopos,
          mg1,mg2,dim1,dim2,xpos,ypos,s,rg,rgrev,p,r,i,j,
          shcd,shop,shfn,show,color,shape},
    dim = Take[Dimensions[st],2];
    rg = Map[Range,dim]; rgrev = Map[Reverse,rg];
    bd = Boundary /. op; bk = (Blocks /. op); sr = SelfRuled /. op;
    step = StepFunction /. op; max = MaxIterations /. op;
    stcd = StopCondition /. op /. Automatic -> (SameQ[#1,#2]&);
    shcd = Switch[s = ShowCondition /. op,{}|0,False&,
                  _Integer,(Mod[#3,s]==0)&,_List,MemberQ[s,#3]&,_,s];
    shop = Flatten[{ShowOptions /. op}]; shfn = ShowFunction /. op;
    color = ColorFunction /. op; shape = ShapeFunction /. op;
    color = If[SameQ[color,Automatic],Nothing,ColorFunction -> color];
    shape = If[SameQ[shape,Automatic],Nothing,ShapeFunction -> shape];
    show = Block[{clop = Options[Cells]},
             Options[Cells] = Flatten[{shop,color,shape,clop}];
             shfn[##];Options[Cells] = clop]&;
    rules = Flatten[{rl},1];
    rules = Switch[rules,{(_Rule|_RuleDelayed)..},{rules},_,rules];
    rules = Map[Dispatch,rules];
    neighs = If[EmptyQ[nb],If[bk === None,{1,1},{0,0}],nb];
    neighs = Switch[neighs,{_Integer,_Integer},{neighs},_,neighs];
    neighs = Map[Reverse,neighs];
    self = If[Not[MatchQ[sr,{__}]],{},
      If[MatchQ[sr[[1]],{_Integer,_Integer}|
                        {{_Integer,_Integer}..}],sr = {sr}];
      sr = Replace[sr,{p:{_Integer,_Integer},r_} :> {{p},r},{1}];
      sr = Replace[sr,{p_,r:(_Rule|_RuleDelayed)} :> {p,{r}},{1}];
      Replace[sr,{p_,r:{(_Rule|_RuleDelayed)..}} :> {p,{r}},{1}]];
    self = MapAt[Cross[- #]&,self,
                 Flatten[Table[{i,1,j},{i,Length[self]},
                                       {j,Length[self[[i,1]]]}],1]];
    self = MapAt[Dispatch,self,
                 Flatten[Table[{i,2,j},{i,Length[self]},
                                       {j,Length[self[[i,2]]]}],1]];
    blocks = bk /. None -> {{1,1},{0,0}};
    blocks = Switch[blocks,
               {{_Integer,_},{_Integer,_}},Map[{#}&,blocks],
               {{_Integer,_},_},MapAt[{#}&,blocks,1],
               {_,{_Integer,_}},MapAt[{#}&,blocks,2],_,blocks];
    blocks = MapAt[Cross[- #]&,blocks,
                   Table[{2,i},{i,Length[blocks[[2]]]}]];
    rlmod = Length[rules]; nbmod = Length[neighs];
    bkmod = Length[blocks[[1]]]; bkomod = Length[blocks[[2]]];
    While[And[iter < max,Not[stop]],
      If[shcd[st1,st0,iter],show[st1,st0,iter]];
      iter++; st0 = st1; stt0 = stt1;
      rlpos = Mod[iter - 1,rlmod] + 1; nbpos = Mod[iter - 1,nbmod] + 1;
      bkpos = Mod[iter - 1,bkmod] + 1; bkopos = Mod[iter - 1,bkomod] + 1;
      nbdim = neighs[[nbpos]]; bkdim = Reverse[blocks[[1,bkpos]]];
      bkori = Mod[blocks[[2,bkopos]],bkdim];
      mg1 = bkdim nbdim + bkori;
      mg2 = bkdim nbdim + Mod[- (dim + mg1),bkdim];
      dim1 = dim + mg1; dim2 = dim1 + mg2;
      Switch[bd,
        Periodic,
          xpos = RotateRight[rg[[1]],mg1[[1]]];
          xpos = PadRight[xpos,dim2[[1]],xpos];
          ypos = RotateRight[rg[[2]],mg1[[2]]];
          ypos = PadRight[ypos,dim2[[2]],ypos];
          st1 = st1[[xpos,ypos]],
        Adiabatic,
          xpos = PadLeft[rg[[1]],dim1[[1]],1];
          xpos = PadRight[xpos,dim2[[1]],dim[[1]]];
          ypos = PadLeft[rg[[2]],dim1[[2]],1];
          ypos = PadRight[ypos,dim2[[2]],dim[[2]]];
          st1 = st1[[xpos,ypos]],
        Symmetric,
          xpos = PadLeft[rg[[1]],dim1[[1]],Rest[rgrev[[1]]]];
          xpos = PadRight[xpos,dim2[[1]],Reverse[Rest[xpos]]];
          ypos = PadLeft[rg[[2]],dim1[[2]],Rest[rgrev[[2]]]];
          ypos = PadRight[ypos,dim2[[2]],Reverse[Rest[ypos]]];
          st1 = st1[[xpos,ypos]],     
        _,st1 = PadRight[PadLeft[st1,dim1,bd],dim2,bd]];
      If[bkdim != {1,1},st1 = Partition[st1,bkdim]];
      If[nbdim != {0,0},st1 = Partition[st1,2 nbdim + 1,{1,1}],{2}];
      st1 = Replace[st1,rules[[rlpos]],{2}];
      If[bkdim != {1,1},
         st1 = Map[Flatten,Flatten[Transpose[st1,{1,3,2,4}],1],2];
         st1 = Take[st1,
                 {mg1[[1]] + 1,dim1[[1]]} - bkdim[[1]] nbdim[[1]],
                 {mg1[[2]] + 1,dim1[[2]]} - bkdim[[2]] nbdim[[2]]]];
      If[Not[EmptyQ[self]],
         Map[Do[st1[[Apply[Sequence,#[[1,i]]]]] = 
                Replace[st1[[Apply[Sequence,#[[1,i]]]]],
                        #[[2,Mod[iter - 1,Length[#[[2]]]] + 1]]], 
                {i,Length[#[[1]]]}]&,self]];
      st1 = step[st1,st0,iter];
      stop = stcd[st1,st0,iter]]; 
      If[Not[SameQ[shcd,False&]],show[st1,st0,iter]];
      st1];




ClearAll[Cells]  

Options[Cells] = 
  {ShapeFunction -> Automatic,ColorFunction -> Automatic,Grid -> True};

Cells[l_List,opts___?OptionQ] :=
  Module[{op = Flatten[{opts,Options[Cells]}],shape,color,
          dim = Reverse[Take[Dimensions[l],2]],x1,x2,y1,y2},
    shape = ShapeFunction /. op; color = ColorFunction /. op;
    If[SameQ[shape,Automatic],
       shape = If[#1 =!= 0,Rectangle[#2 - .5,#2 + .5]]&];
    If[SameQ[color,Automatic],color = GrayLevel[0]&];
    x1 = y1 = .5; x2 = dim[[1]] + .5; y2 = dim[[2]] + .5; 
    Graphics[{{GrayLevel[1],Rectangle[{x1,y1},{x2,y2}]},
              MapIndexed[If[NullQ[s = shape[#1,#2]],
                            Nothing,{color[#1,#2],s}]&,
                            Thread[Reverse[l]],{2}],
              If[Grid /. op,
                 {GrayLevel[.5],
                  Table[Line[{{x1,y},{x2,y}}],{y,y1,y2}],
                  Table[Line[{{x,y1},{x,y2}}],{x,x1,x2}]},
                 Nothing]},
             Select[op,FreeQ[#,Grid|ShapeFunction|ColorFunction]&],
             Frame -> True,FrameTicks -> Range[1,dim],
             PlotRange -> {{.25,dim[[1]] + .75},{.25,dim[[2]] + .75}},
             AspectRatio -> Automatic]]




Unprotect[Random];

Random[l_List] := l[[Random[Integer,{1,Length[l]}]]]

Random[l_List,p_List] := 
  Module[{r = Random[],c = N[FoldList[Plus,First[p],Rest[p]]]},
    l[[FirstPosition[c / Last[c],_?((r <= #)&)]]]]

Protect[Random];
