(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)





ClearAll[Voronoi,CircCenter]

Voronoi[pts_List] := 
  Module[{x1 = Min[Thread[pts][[1]]],x2 = Max[Thread[pts][[1]]], 
          y1 = Min[Thread[pts][[2]]],y2 = Max[Thread[pts][[2]]], 
          tri = Triangulation[pts,Method -> Delaunay,Mode -> DCEList], 
          x0,y0,lx,ly,l,f0,vlist,elist,flist,coord,vor,n,
          f,ft,e,t,nt,fe,ce,ne,pe,ve,p1,p2,newe,newv},
    x0 = (x1 + x2)/2; y0 = (y1 + y2)/2; 
    lx = x2 - x1; x1 = x0 - 0.6 lx; x2 = x0 + 0.6 lx;
    ly = y2 - y1; y1 = y0 - 0.6 ly; y2 = y0 + 0.6 ly;
    l = lx + ly; 
    f0 = UnboundedFace[tri];
    vlist = ReplacePart[Map[TwinEdge,FaceList[tri],{2}],Null,f0];
    coord = vlist /. {e_Integer} :> 
      (f = EdgeFace[tri,TwinEdge[e]];
       CircCenter[VertexCoord[tri,FaceOuterVertices[tri,f]]]);
    flist = ReplacePart[VertexList[tri],Null,
                        Thread[{FaceInnerVertices[tri,f0][[1]]}]];
    AppendTo[flist,{0,0}];
    elist = EdgeList[tri]; 
    newe = Length[elist] + 1; newv = Length[vlist] + 1;
    elist = elist /. {f_,_,p_,n_,v_} :> 
        (e = PrevEdge[tri,n]; t = TwinEdge[e];
         ft = EdgeFace[tri,t]; nt = NextEdge[tri,t];
         fe = If[NullQ[flist[[v]]],flist[[-1,2]] = e;Length[flist],v];
         ce = If[NullQ[flist[[v]]],2,1];
         pe = If[ft != f0,nt,t];
         ne = If[f != f0,TwinEdge[p],t];
         ve = If[ft != f0,ft,
                 AppendTo[vlist,{e}]; 
                 AppendTo[coord,
                          p1 = VertexCoord[tri,v]; 
                          p2 = VertexCoord[tri,EdgeEnd[tri,e]]; 
                          (p1 + p2)/2 + l Cross[p2 - p1]/
                            Sqrt[(p2 - p1).(p2 - p1)]];newv++];
         {fe,ce,pe,ne,ve});
    BoxClip[DCEList[flist,elist,vlist,coord],{{x1,x2},{y1,y2}}]]
    
CircCenter[{{x1_,y1_},{x2_,y2_},{x3_,y3_}}] := 
  {-Det[{{1,1,1},{y1,y2,y3},{x1^2 + y1^2,x2^2 + y2^2,x3^2 + y3^2}}], 
   +Det[{{1,1,1},{x1,x2,x3},{x1^2 + y1^2,x2^2 + y2^2,x3^2 + y3^2}}]}/
   (2 Det[{{1,x1,y1},{1,x2,y2},{1,x3,y3}}])








ClearAll[BSPTree,BSPTreeToDCEList,SplitFace]

BSPTreeToDCEList[t_Tree,{{x1_,x2_},{y1_,y2_}}] :=  
  Module[{dce,split},
    split[bsp_,f_] :=
      If[Not[LeafQ[bsp]],
         dce = SplitFace[dce,f,GetKey[bsp]];
         split[GetBranch[bsp,2],Length[FaceList[dce]]];
         split[GetBranch[bsp,1],f]];
    dce = RegionToDCEList[Polygon[{{x1,y1},{x2,y1},{x2,y2},{x1,y2}}]];
    split[t,1]; dce] 
    
SplitFace[dce_DCEList,f_,{v:{_,_},c_}] :=
  Module[{loop = FaceOuterBoundary[dce,f],
          dce1 = dce,val,pos1,pos2,t,v1,v2,p1,p2},
    val = Map[Chop[v . VertexCoord[dce,EdgeOrigin[dce,#]] - c]&,loop];
    AppendTo[val,First[val]]; AppendTo[loop,First[loop]];
    Switch[val = Append[val,First[val]],
      {_?NonPositive ..}|{_?NonNegative ..},dce,
      _,pos1 = FirstRelPosition[val,And[#1 < 0,#2 >= 0]&];
        pos2 = FirstRelPosition[val,And[#1 > 0,#2 <= 0]&];
      v1 = VertexCoord[dce,EdgeOrigin[dce,loop[[pos1]]]];
      v2 = VertexCoord[dce,EdgeOrigin[dce,loop[[pos1 + 1]]]];
      t = val[[pos1]] / (val[[pos1 + 1]] - val[[pos1]]);
      p1 = (1 + t) v1 - t v2;
      v1 = VertexCoord[dce,EdgeOrigin[dce,loop[[pos2]]]];
      v2 = VertexCoord[dce,EdgeOrigin[dce,loop[[pos2 + 1]]]];
      t = val[[pos2]] / (val[[pos2 + 1]] - val[[pos2]]);
      p2 = (1 + t) v1 - t v2;
      If[val[[pos1 + 1]] != 0,dce1 = SplitEdge[dce1,loop[[pos1]],p1]];
      If[val[[pos2 + 1]] != 0,dce1 = SplitEdge[dce1,loop[[pos2]],p2]];
      InsertEdge[dce1,loop[[pos1]],NextEdge[dce1,loop[[pos1]]],
                      loop[[pos2]],NextEdge[dce1,loop[[pos2]]]]]]




ClearAll[PainterList]

PainterList[bsp_Tree,p:{_,_}] := 
  If[LeafQ[bsp],GetData[bsp],
     If[GetKey[bsp][[1]] . p - GetKey[bsp][[2]] >= 0,
        Join[PainterList[GetBranch[bsp,1],p],
             GetData[bsp],PainterList[GetBranch[bsp,2],p]],
        Join[PainterList[GetBranch[bsp,2],p],GetData[bsp],
             PainterList[GetBranch[bsp,1],p]]]]






ClearAll[OrdTree2DToBSPTree,OrdTree2DToDCEList]

OrdTree2DToBSPTree[t2d_Tree] :=  
  Module[{tobsp},
    tobsp[t_,l_] :=
      If[LeafQ[t],t,
         Tree[{{If[OddQ[l],{1,0},{0,1}],GetKey[t]},GetData[t]},
              tobsp[GetBranch[t,1],l + 1],tobsp[GetBranch[t,2],l + 1]]];
    tobsp[t2d,1]] 

OrdTree2DToDCEList[t2d_Tree,{{x1_,x2_},{y1_,y2_}}] :=  
  BSPTreeToDCEList[OrdTree2DToBSPTree[t2d],{{x1,x2},{y1,y2}}]
    



ClearAll[OrdTree2D]

OrdTree2D[pts_List] := 
  Module[{tree},
    tree[p_,l_] :=
      If[Length[p] < 2,Tree[{Null,p}],
         Module[{s,m,c,t1,t2,odd = OddQ[l]},
           s = Sort[p,If[odd,OrderedQ[{#1,#2}]&,
                         OrderedQ[{Reverse[#1],Reverse[#2]}]&]];
           m = Floor[Length[s] / 2];
           c = (s[[m]] + s[[m + 1]]) / 2;
           t1 = tree[Take[s,m],l + 1];
           t2 = tree[Drop[s,m],l + 1];
           Tree[{If[odd,c[[1]],c[[2]]],{}},t1,t2]]];
       tree[pts,1]]




ClearAll[OrdTree2DSearch]

OrdTree2DSearch[t2d_Tree,{{x1_,x2_},{y1_,y2_}}] := Null








ClearAll[QuadTreeContent,QuadTreeRange]

QuadTreeContent[qt_Tree] := GetBranch[qt,1]

QuadTreeRange[qt_Tree] := GetNode[qt]




ClearAll[QuadTreeToDCEList]

QuadTreeToDCEList[qt_Tree] :=  
  Module[{dce,split,x1,x2,y1,y2,xm,ym},
    split[t_,f_,{{x1_,x2_},{y1_,y2_}}] :=
      If[Not[LeafQ[t]],
         Module[{xm = (x1 + x2)/2,ym = (y1 + y2)/2,f1,f2,f3},
           dce = SplitFace[dce,f,{{1,0},xm}];
           dce = SplitFace[dce,Length[FaceList[dce]],{{0,1},ym}];
           dce = SplitFace[dce,f,{{0,1},ym}];
           f1 = Length[FaceList[dce]] - 2; f2 = f1 + 2; f3 = f1 + 1;
           split[GetBranch[t,1],f,{{x1,xm},{y1,ym}}];
           split[GetBranch[t,2],f1,{{xm,x2},{y1,ym}}];
           split[GetBranch[t,3],f2,{{x1,xm},{ym,y2}}];
           split[GetBranch[t,4],f3,{{xm,x2},{ym,y2}}]]];
    {{x1,x2},{y1,y2}} = QuadTreeRange[qt];
    dce = RegionToDCEList[Polygon[{{x1,y1},{x2,y1},{x2,y2},{x1,y2}}]];
    split[QuadTreeContent[qt],1,{{x1,x2},{y1,y2}}]; dce] 




ClearAll[QuadTree]

QuadTree[pts_List,rg:{{_,_},{_,_}}] := 
  Module[{tree},
    tree[p_,{{x1_,x2_},{y1_,y2_}}] :=
      If[Length[p] < 2,Tree[{Null,p}],
         Module[{xm = (x1 + x2)/2,ym = (y1 + y2)/2,
                 p1 = {},p2 = {},p3 = {},p4 = {}},
           Scan[Switch[{#[[1]] < xm,#[[2]] < ym},
                  {True,True},AppendTo[p1,#],
                  {False,True},AppendTo[p2,#],
                  {True,False},AppendTo[p3,#],
                  {False,False},AppendTo[p4,#]]&,p];
           Tree[Null,tree[p1,{{x1,xm},{y1,ym}}],
                     tree[p2,{{xm,x2},{y1,ym}}],
                     tree[p3,{{x1,xm},{ym,y2}}],
                     tree[p4,{{xm,x2},{ym,y2}}]]]];
    Tree[rg,tree[pts,rg]]]
