(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)





ClearAll[InsideTriangleQ,InsideCircleQ]

InsideTriangleQ[{{x1_,y1_},{x2_,y2_},{x3_,y3_}},{x_,y_}] :=
  SameQ[1,TriangleClass[{{x1,y1},{x2,y2},{x,y}}],
          TriangleClass[{{x1,y1},{x,y},{x3,y3}}],
          TriangleClass[{{x,y},{x2,y2},{x3,y3}}]]

InsideCircleQ[{{x1_,y1_},{x2_,y2_},{x3_,y3_}},{x_,y_}] :=
  SameQ[Sign[Chop[Det[{{1,x1,y1,x1^2 + y1^2},{1,x2,y2,x2^2 + y2^2},
                       {1,x3,y3,x3^2 + y3^2},{1,x,y,x^2 + y^2}}]]],-1]




ClearAll[Triangulation,TriangleList,Sweep,Delaunay]
Options[Triangulation] = 
  {Method -> Delaunay,Indexed -> False,Mode -> DCEList};

Triangulation[pts_List,opts___?OptionQ] :=
  Module[{op = Flatten[{opts,Options[Triangulation]}],ind,tr,l,i = 1},
    Switch[Method /. op,
      Sweep,
        ind = Sort[Range[Length[pts]],OrderedQ[pts[[{#1,#2}]]]&];
        tr = SweepTR[ind,N[pts]],
      Delaunay,
        ind = RandomPermutation[Length[pts]];
        tr = DelaunayTR[ind,N[pts]]];
    Switch[Mode /. op,
      EdgeList,
        l = Map[{EdgeOrigin[tr,#],EdgeEnd[tr,#]}&,
                Flatten[Partition[Edges[tr],1,2]]];
        l = l /. Dispatch[Map[Rule[i++,#]&,ind]];
        If[Indexed /. op,l,l /. i_Integer :> pts[[i]]],
      TriangleList,
        l = Map[FaceOuterVertices[tr,#]&,BoundedFaces[tr]];
        l = l /. Dispatch[Map[Rule[i++,#]&,ind]];
        If[Indexed /. op,l,l /. i_Integer :> pts[[i]]],
      DCEList,tr]]

ClearAll[SweepTR,DelaunayTR]

SweepTR[pts_,coord_] := 
  Module[{tr = DCEList[],i = 2,v1,v2,e1,e2,e3,f,p1,p2,l},
    If[Length[pts] < 2,tr,
       tr = InsertEdge[tr,1,coord[[pts[[1]]]],coord[[pts[[2]]]]];
       While[i++ < Length[pts],
         v1 = Length[VertexList[tr]];
         f = UnboundedFace[tr];
         e2 = Select[VertexEdgeList[tr,v1],
                     SameQ[EdgeFace[tr,#],f]&,1][[1]];
         e1 = PrevEdge[tr,e2];
         l = EdgeLoop[tr,e2];
         tr = InsertEdge[tr,e1,e2,coord[[pts[[i]]]]];
         v2 = v1 + 1;
         e3 = PrevEdge[tr,e2];
         p1 = LastPosition[l,
                _?((PointLineClass[VertexCoord[tr,v2],
                    {VertexCoord[tr,EdgeOrigin[tr,#]],
                     VertexCoord[tr,EdgeEnd[tr,#]]}] < 1)&)];
         p2 = FirstPosition[l,
                _?((PointLineClass[VertexCoord[tr,v2],
                    {VertexCoord[tr,EdgeOrigin[tr,#]],
                     VertexCoord[tr,EdgeEnd[tr,#]]}] < 1)&)];
         e1 = NextEdge[tr,e1];
         Do[e2 = Length[EdgeList[tr]];
            tr = InsertEdge[tr,l[[j]],l[[j + 1]],e1,e2], 
            {j,p1,Length[l] - 1}];
         e1 = PrevEdge[tr,e3];
         Do[e2 = NextEdge[tr,e1];
            tr = InsertEdge[tr,l[[j-1]],l[[j]],e1,e2],
            {j,2,p2}]]; tr]]

DelaunayTR[pts_,coord_] := 
  Module[{m = Max[Abs[coord]],tr,lkf,lke,lkp,split,swap,delq,mkdel,
          e,x,v,n,i,j,l,e0,e1,e2,e3,e4,e5,e6,e7,t1,f,f1,f2,f3,f4,
          v1,v2,v3,v4,p0,p1,p2,p3,p4,vi,ci},
    tr = RegionToDCEList[Polygon[{{- 4 m,- 4 m},{4 m,0},{0,4 m}}]];
    lkf = {pts,{}}; lke = {{},{},{}}; 
    lkp = Table[{1,Null},{Length[pts]}];
    split[{Null,e_},x_] := 
      (e0 = 2 e; e1 = NextEdge[tr,e0]; e2 = NextEdge[tr,e1];
       e3 = NextEdge[tr,TwinEdge[e0]]; e4 = NextEdge[tr,e3];
       tr = SplitEdge[tr,e0,x]; e5 = NextEdge[tr,e4]; 
       e6 = NextEdge[tr,e5]; e7 = NextEdge[tr,e0]; 
       p0 = VertexCoord[tr,EdgeOrigin[tr,e7]]; 
       p1 = VertexCoord[tr,EdgeOrigin[tr,e1]]; 
       p2 = VertexCoord[tr,EdgeOrigin[tr,e2]]; 
       p4 = VertexCoord[tr,EdgeOrigin[tr,e4]];
       tr = InsertEdge[tr,e0,e7,e1,e2];
       tr = InsertEdge[tr,e3,e4,e5,e6]; 
       f1 = EdgeFace[tr,e1]; f2 = EdgeFace[tr,e2];
       f3 = EdgeFace[tr,e3]; f4 = EdgeFace[tr,e4];
       n = Length[lke]; lke = Join[lke,{{},{},{}}]; 
       v = lke[[e]]; lke[[e]] = {}; lkf = Join[lkf,{{},{}}];
       i = 0; While[i++ < Length[v],
                If[PointLineClass[coord[[vi = v[[i]]]],{p0,p1}] == 0,
                   lkp[[vi]] = {Null,n + 1}; AppendTo[lke[[-3]],vi],
                   lkp[[vi]] = {Null,e}; AppendTo[lke[[e]],vi]]];                          
       v = Apply[Join,lkf[[{f1,f2}]]]; lkf[[{f1,f2}]] = {};     
       i = 0; While[i++ < Length[v],
                Switch[PointLineClass[coord[[vi = v[[i]]]],{p0,p2}],
                  1,lkp[[vi]] = {f2,Null}; AppendTo[lkf[[f2]],vi],
                  0,lkp[[vi]] = {Null,n + 2}; AppendTo[lke[[-2]],vi],
                  _,lkp[[vi]] = {f1,Null}; AppendTo[lkf[[f1]],vi]]];          
       v = Apply[Join,lkf[[{f3,f4}]]]; lkf[[{f3,f4}]] = {};     
       i = 0; While[i++ < Length[v],
                Switch[PointLineClass[coord[[vi = v[[i]]]],{p0,p4}],
                  1,lkp[[vi]] = {f4,Null}; AppendTo[lkf[[f4]],vi],
                  0,lkp[[vi]] = {Null,n + 3}; AppendTo[lke[[-1]],vi],
                  _,lkp[[vi]] = {f3,Null}; AppendTo[lkf[[f3]],vi]]];
       mkdel[e1]; mkdel[e2]; mkdel[e3]; mkdel[e4]);
    split[{f_,Null},x_] := 
      (e1 = FaceOuterEdge[tr,f]; 
       e2 = NextEdge[tr,e1]; e3 = NextEdge[tr,e2];
       tr = InsertEdge[tr,e1,e2,x];
       e4 = NextEdge[tr,e1]; e5 = NextEdge[tr,e4];
       tr = InsertEdge[tr,e2,e3,e4,e5]; e6 = NextEdge[tr,e4];
       tr = InsertEdge[tr,e3,e1,e4,e6]; 
       f1 = EdgeFace[tr,e1]; f2 = EdgeFace[tr,e2]; f3 = EdgeFace[tr,e3];
       n = Length[lke]; lke = Join[lke,{{},{},{}}];
       lkf = Join[lkf,{{},{}}];
       v = Apply[Join,lkf[[{f1,f2,f3}]]]; lkf[[{f1,f2,f3}]] = {};
       p0 = VertexCoord[tr,EdgeOrigin[tr,e6]]; 
       p1 = VertexCoord[tr,EdgeOrigin[tr,e1]]; 
       p2 = VertexCoord[tr,EdgeOrigin[tr,e2]]; 
       p3 = VertexCoord[tr,EdgeOrigin[tr,e3]];
       i = 0; While[i++ < Length[v], 
                ci = coord[[vi = v[[i]]]];
                Switch[{PointLineClass[ci,{p0,p1}],
                        PointLineClass[ci,{p0,p2}],
                        PointLineClass[ci,{p0,p3}]},
                  {1,-1,_},lkp[[vi]] = {f1,Null}; 
                           AppendTo[lkf[[f1]],vi],
                  {_,1,-1},lkp[[vi]] = {f2,Null}; 
                           AppendTo[lkf[[f2]],vi],
                  {-1,_,1},lkp[[vi]] = {f3,Null}; 
                           AppendTo[lkf[[f3]],vi],
                  {0,_,_},lkp[[vi]] = {Null,n + 3};
                          AppendTo[lke[[-1]],vi],
                  {_,0,_},lkp[[vi]] = {Null,n + 1};
                          AppendTo[lke[[-3]],vi],
                  {_,_,0},lkp[[vi]] = {Null,n + 2}; 
                          AppendTo[lke[[-2]],vi]]];
       mkdel[e1]; mkdel[e2]; mkdel[e3]);
    delq[e1_] :=
      Switch[Sign[{v1 = EdgeOrigin[tr,e1],
                   v2 = EdgeOrigin[tr,t1 = TwinEdge[e1]],
                   v3 = EdgeOrigin[tr,PrevEdge[tr,e1]],
                   v4 = EdgeOrigin[tr,PrevEdge[tr,t1]]} - 3],
        {1,1,1,1},DelaunayEdgeQ[tr,e1],
        {_,1,1,1},PolygonClass[VertexCoord[tr,{v2,v3,v4}]] <= 0,
        {1,_,1,1},PolygonClass[VertexCoord[tr,{v1,v3,v4}]] >= 0,
        {1,1,_,1}|{1,1,1,_}|{-1|0,-1|0,_,_},True,
        {_,_,_,_},DelaunayEdgeQ[tr,e1] || Min[v1,v2] < Min[v3,v4]];
    mkdel[e1_] := 
      If[Not[delq[e1]], t1 = TwinEdge[e1];
         Module[{e2 = NextEdge[tr,t1],e3 = PrevEdge[tr,t1]},
           swap[e1]; mkdel[e2]; mkdel[e3]]];
    swap[e1_] :=
      (Module[{e,e2,e3,e4},
       e = Quotient[e1 + 1,2]; e2 = TwinEdge[e1];
       f1 = EdgeFace[tr,e1]; f2 = EdgeFace[tr,e2];
       e3 = PrevEdge[tr,e1]; e4 = PrevEdge[tr,e2];  
       tr = SwapEdge[tr,e1];
       f3 = EdgeFace[tr,e3]; f4 = EdgeFace[tr,e4];
       p1 = VertexCoord[tr,EdgeOrigin[tr,e3]];
       p2 = VertexCoord[tr,EdgeOrigin[tr,e4]];
       v = Union[lkf[[f1]],lkf[[f2]],lke[[e]]];
       lkf[[{f1,f2}]] = {}; AppendTo[lkf,{}]; 
       n = Length[lke]; lke[[e]] = {}; AppendTo[lke,{}];
       i = 0; While[i++ < Length[v],
               Switch[PointLineClass[coord[[vi = v[[i]]]],{p1,p2}],
                 1,lkp[[vi]] = {f4,Null}; AppendTo[lkf[[f4]],vi],
                 0,lkp[[vi]] = {Null,n + 1}; AppendTo[lke[[-1]],vi],        
                 _,lkp[[vi]] = {f3,Null}; AppendTo[lkf[[f3]],vi]]]]);           
    j = 0; While[j++ < Length[pts],
             split[lkp[[pts[[j]]]],coord[[pts[[j]]]]]];
    l = Apply[Union,Table[VertexEdgeList[tr,i],{i,1,3}]];
    tr = Fold[DeleteEdge,tr,Complement[l,{1,3,5}]]; tr]
 



ClearAll[SwapEdge]

SwapEdge[tri_DCEList,e_] :=
  Module[{e1,e2,e3,e4}, 
          e2 = NextEdge[tri,e1 = NextEdge[tri,e]];
          e4 = NextEdge[tri,e3 = NextEdge[tri,TwinEdge[e]]];
          InsertEdge[DeleteEdge[tri,e],e1,e2,e3,e4]]




ClearAll[DelaunayEdgeQ,DelaunayQ,MakeDelaunay]
          
DelaunayEdgeQ[tri_DCEList,e_] :=
  Module[{t = TwinEdge[e]},
    Not[BoundedQ[tri,EdgeFace[tri,e]] &&
        BoundedQ[tri,EdgeFace[tri,t]] &&
        InsideCircleQ[VertexCoord[tri,{EdgeOrigin[tri,e],EdgeEnd[tri,e],
                                       EdgeEnd[tri,NextEdge[tri,e]]}],
                      VertexCoord[tri,EdgeEnd[tri,NextEdge[tri,t]]]]]]

DelaunayQ[tri_DCEList] :=
  Module[{l = Flatten[Partition[Edges[tri],1,2]],t = True,n,i = 1},
    n = Length[l];
    While[And[t,i < n],
          If[Not[DelaunayEdgeQ[tri,l[[i++]]]],t = False]]; t]

MakeDelaunay[tri_DCEList] :=
  Module[{tr = tri,l,p},
    While[Not[NullQ[p = FirstPosition[
                          l = Flatten[Partition[Edges[tr],1,2]],
                          _?(Not[DelaunayEdgeQ[tr,#]]&)]]],
          tr = SwapEdge[tr,l[[p]]]]; tr]




ClearAll[MinSpanningTree]
          
MinSpanningTree[tri_DCEList] := 
  Module[{l = Sort[Flatten[Partition[Edges[tri],1,2]],
                (EdgeLength[tri,#1] > EdgeLength[tri,#2])&],
          i = 1,tr = tri,e,t},  
    While[Length[Faces[tr]] > 1,
      e = l[[i++]]; t = TwinEdge[e];
      If[EdgeFace[tr,e] != EdgeFace[tr,t],tr = DeleteEdge[tr,e]]]; tr]




ClearAll[CircCenter, Voronoi]

CircCenter[{{x1_,y1_},{x2_,y2_},{x3_,y3_}}] := 
  {-Det[{{1,1,1},{y1,y2,y3},{x1^2 + y1^2,x2^2 + y2^2,x3^2 + y3^2}}], 
   +Det[{{1,1,1},{x1,x2,x3},{x1^2 + y1^2,x2^2 + y2^2,x3^2 + y3^2}}]}/
   (2 Det[{{1,x1,y1},{1,x2,y2},{1,x3,y3}}])

Voronoi[pts_List] := 
  Module[{x1 = Min[Thread[pts][[1]]],x2 = Max[Thread[pts][[1]]], 
          y1 = Min[Thread[pts][[2]]],y2 = Max[Thread[pts][[2]]], 
          tri = Triangulation[pts,Method -> Delaunay,Mode -> DCEList], 
          x0,y0,lx,ly,l,f0,vlist,elist,flist,coord,vor,n,
          f,ft,e,t,nt,fe,ce,ne,pe,ve,p1,p2,newe,newv},
    x0 = (x1 + x2)/2; y0 = (y1 + y2)/2; 
    lx = x2 - x1; x1 = x0 - 0.6 lx; x2 = x0 + 0.6 lx;
    ly = y2 - y1; y1 = y0 - 0.6 ly; y2 = y0 + 0.6 ly;
    l = lx + ly; 
    f0 = UnboundedFace[tri];
    vlist = ReplacePart[Map[TwinEdge,FaceList[tri],{2}],Null,f0];
    coord = vlist /. {e_Integer} :> 
      (f = EdgeFace[tri,TwinEdge[e]];
       CircCenter[VertexCoord[tri,FaceOuterVertices[tri,f]]]);
    flist = ReplacePart[VertexList[tri],Null,
                        Thread[{FaceInnerVertices[tri,f0][[1]]}]];
    AppendTo[flist,{0,0}];
    elist = EdgeList[tri]; 
    newe = Length[elist] + 1; newv = Length[vlist] + 1;
    elist = elist /. {f_,_,p_,n_,v_} :> 
        (e = PrevEdge[tri,n]; t = TwinEdge[e];
         ft = EdgeFace[tri,t]; nt = NextEdge[tri,t];
         fe = If[NullQ[flist[[v]]],flist[[-1,2]] = e;Length[flist],v];
         ce = If[NullQ[flist[[v]]],2,1];
         pe = If[ft != f0,nt,t];
         ne = If[f != f0,TwinEdge[p],t];
         ve = If[ft != f0,ft,
                 AppendTo[vlist,{e}]; 
                 AppendTo[coord,
                          p1 = VertexCoord[tri,v]; 
                          p2 = VertexCoord[tri,EdgeEnd[tri,e]]; 
                          (p1 + p2)/2 + l Cross[p2 - p1]/
                            Sqrt[(p2 - p1).(p2 - p1)]];newv++];
         {fe,ce,pe,ne,ve});
    BoxClip[DCEList[flist,elist,vlist,coord],{{x1,x2},{y1,y2}}]]




ClearAll[TriangulatePolygon]
Options[TriangulatePolygon] = 
  {Method -> Sweep,Indexed -> False,Mode -> DCEList};

TriangulatePolygon[pts_List,opts___?OptionQ] :=
  Module[{op = Flatten[{opts,Options[TriangulatePolygon]}],tr,l,i},  
    Switch[Method /. op,
      Reduce,tr = ReduceTP[RegionToDCEList[Polygon[N[pts]]],1],
      Split,tr = SplitTP[RegionToDCEList[Polygon[N[pts]]],1],
      Sweep,tr = SweepTP[RegionToDCEList[Polygon[N[pts]]],1]];
    Switch[Mode /. op,
      EdgeList,
        l = Map[{EdgeOrigin[tr,#],EdgeEnd[tr,#]}&,
                Flatten[Partition[Edges[tr],1,2]]];
        If[Indexed /. op,l,l /. i_Integer :> pts[[i]]],
      TriangleList,
        l = Map[FaceOuterVertices[tr,#]&,BoundedFaces[tr]];
        If[Indexed /. op,l,l /. i_Integer :> pts[[i]]],
      DCEList,tr]]

Clear[ReduceTP,SplitTP,SweepTP]

ReduceTP[dce_,f_] :=
  Module[{bd = FaceOuterBoundary[dce,f],v,d,e1,e2,dce1},
    If[Length[bd] <= 3,dce,
       v = VertexCoord[dce,Map[EdgeOrigin[dce,#]&,bd]];
       d = FindShortDiagonal[v,Indexed -> True]; 
       {e1,e2} = bd[[d]];
       dce1 = InsertEdge[dce,PrevEdge[dce,e1],e1,PrevEdge[dce,e2],e2];
       ReduceTP[dce1,EdgeFace[dce1,e1]]]]

SplitTP[dce_,f_] := 
  Module[{bd = FaceOuterBoundary[dce,f],v,d,e1,e2,dce1},
    If[Length[bd] <= 3,dce,
       v = VertexCoord[dce,Map[EdgeOrigin[dce,#]&,bd]];
       d = FindDiagonal[v,Indexed -> True]; 
       {e1,e2} = bd[[d]];
       dce1 = InsertEdge[dce,PrevEdge[dce,e1],e1,PrevEdge[dce,e2],e2];
       dce1 = SplitTP[dce1,EdgeFace[dce1,e1]];
       SplitTP[dce1,EdgeFace[dce1,e2]]]]
   
SweepTP[dce_,f_] := Triangulate[dce,f]
  



ClearAll[Triangulate,MakeMonotone]

Triangulate[dce_DCEList] := Triangulate[dce,BoundedFaces[dce]]

Triangulate[dce_DCEList,l_List] := Fold[Triangulate,dce,l]

Triangulate[dce_DCEList,f_] := 
  Module[{triang,sweep,insedge,dce0,dce1,m,l,v1,v2,
          X = 1,SIDE = 2,PE = 3,NE = 4,upper = 1,lower = -1},
    triang[dce0_,m_] := 
      Module[{bd = FaceOuterBoundary[dce0,m],vl,sd,l}, 
        vl = Map[VertexCoord[dce0,EdgeOrigin[dce0,#1]]&,bd]; 
        sd = - Apply[Order,Partition[vl,2,1,1],1];
        l = Sort[Thread[{vl,sd,RotateRight[bd],bd}]];
        If[Length[l] <= 3,dce0,sweep[dce0,Drop[l,2],Take[l,2]]]];
    sweep[dce0_,l_,st_] :=
      Module[{dce1 = dce0,st1 = st,v = First[l],w = Last[st],n},
        If[Length[l] == 1,
           Switch[w[[SIDE]],
             upper,p = 1;
               While[p++ < Length[st1] - 1,
                     dce1 = insedge[dce1,st1[[p]],v];
                     n = Length[EdgeList[dce1]] - 1;
                     v = ReplacePart[v,n,PE]]; dce1,
             lower,p = 1;
               While[p++ < Length[st1] - 1,
                     dce1 = insedge[dce1,st1[[p]],v];
                     n = Length[EdgeList[dce1]];
                     v = ReplacePart[v,n,NE]]]; dce1,
           Switch[{w[[SIDE]],v[[SIDE]]},
             {upper,upper},
               p = Length[st1];
               While[And[p-- > 1,LineSlope[st1[[{p,p + 1},X]]] >
                                   LineSlope[{st1[[p + 1,X]],v[[X]]}]],
                     dce1 = insedge[dce1,st1[[p]],v];
                     n = Length[EdgeList[dce1]];
                     st1[[p]] = ReplacePart[st1[[p]],n,PE];
                     v = ReplacePart[v,n,NE]];
               sweep[dce1,Rest[l],Append[Take[st1,p + 1],v]],
             {upper,lower},
               p = 1;
               While[p++ < Length[st1],
                     dce1 = insedge[dce1,st1[[p]],v];
                     n = Length[EdgeList[dce1]] - 1;
                     v = ReplacePart[v,n,PE]];
               sweep[dce1,Rest[l],{ReplacePart[w,n,NE],v}],
             {lower,upper},
               p = 1;
               While[p++ < Length[st1],
                     dce1 = insedge[dce1,st1[[p]],v];
                     n = Length[EdgeList[dce1]];
                     v = ReplacePart[v,n,NE]];
               sweep[dce1,Rest[l],{ReplacePart[w,n,PE],v}],
             {lower,lower},
               p = Length[st1];
               While[And[p-- > 1,LineSlope[st1[[{p,p + 1},X]]] <
                                   LineSlope[{st1[[p + 1,X]],v[[X]]}]],
                     dce1 = insedge[dce1,st1[[p]],v];
                     n = Length[EdgeList[dce1]] - 1;
                     st1[[p]] = ReplacePart[st1[[p]],n,NE];
                     v = ReplacePart[v,n,PE]];
               sweep[dce1,Rest[l],Append[Take[st1,p + 1],v]]]]];
    insedge[dce0_,v1_,v2_] := 
      InsertEdge[dce0,v1[[PE]],v1[[NE]],v2[[PE]],v2[[NE]]];
    dce1 = MakeMonotone[dce,f];
    l := Join[{f},Range[Length[Faces[dce]] + 1,Length[Faces[dce1]]]];
    Fold[triang,dce1,l]]

MakeMonotone[dce_DCEList] := MakeMonotone[dce,BoundedFaces[dce]]

MakeMonotone[dce_DCEList,l_List] := Fold[MakeMonotone,dce,l]

MakeMonotone[dce_DCEList,f_] := 
  Module[{sweep,insedge,height,ord,helper,dce0,v1,v2,e,x,bd,vl,tp,l,
          end = 0,lower = 1,upper = 2,split = 3,merge = 4,start = 5,
          X = 1,TYPE = 2,PE = 3,NE = 4},      
    sweep[dce0_,l_,st_] :=
      If[EmptyQ[l],dce0,
      Module[{dce1 = dce0,st1 = st,v = First[l],w,e,n},
        x = v[[X,1]];
        Switch[v[[TYPE]],
          start,
            e = v[[NE]];
            st1 = OrdTreeInsert[st1,{height[e],e},ord[x]];
            helper[e] = v;
            sweep[dce1,Rest[l],st1],
          end,
            e = v[[PE]];
            w = helper[e];
            If[SameQ[w[[TYPE]],merge],
               dce1 = insedge[dce1,w,v]];
            st1 = OrdTreeDelete[st1,height[e],ord[x]];
            sweep[dce1,Rest[l],st1],
          lower,
            e = v[[PE]];
            w = helper[e];
            If[SameQ[w[[TYPE]],merge],
               dce1 = insedge[dce1,w,v];
               n = Length[EdgeList[dce1]] - 1;
               v[[PE]] = n];
            st1 = OrdTreeDelete[st1,height[e],ord[x]];
            e = v[[NE]];
            st1 = OrdTreeInsert[st1,{height[e],e},ord[x]];
            helper[e] = v;
            sweep[dce1,Rest[l],st1],
          upper,
            e = GetData[OrdTreeLower[st1,v[[X,2]]&,ord[x]]];
            w = helper[e];
            If[SameQ[w[[TYPE]],merge],
               dce1 = insedge[dce1,w,v];
               n = Length[EdgeList[dce1]];
               v[[NE]] = n];
            helper[e] = v;
            sweep[dce1,Rest[l],st1],
          split,
            e = GetData[OrdTreeLower[st1,v[[X,2]]&,ord[x]]];
            w = helper[e];
            dce1 = insedge[dce1,w,v];
            n = Length[EdgeList[dce1]];
            helper[e] = ReplacePart[v,n,NE];
            e = v[[NE]];
            st1 = OrdTreeInsert[st1,{height[e],e},ord[x]];
            helper[e] = ReplacePart[v,n - 1,PE];
            sweep[dce1,Rest[l],st1],
          merge,
            e = v[[PE]];
            w = helper[e];
            If[SameQ[w[[TYPE]],merge],
               dce1 = insedge[dce1,w,v];
               n = Length[EdgeList[dce1]] - 1;
               v[[PE]] = n];
            st1 = OrdTreeDelete[st1,height[e],ord[x]];
            e = GetData[OrdTreeLower[st1,v[[X,2]]&,ord[x]]];
            w = helper[e];
            If[SameQ[w[[TYPE]],merge],
               dce1 = insedge[dce1,w,v];
               n = Length[EdgeList[dce1]];
               v[[NE]] = n];
            helper[e] = v;
            sweep[dce1,Rest[l],st1]]]];
    insedge[dce0_,v1_,v2_] := 
      InsertEdge[dce0,v1[[PE]],v1[[NE]],v2[[PE]],v2[[NE]]];
    height[e_][x_] := 
      Module[{v1 = VertexCoord[dce,EdgeOrigin[dce,e]],
              v2 = VertexCoord[dce,EdgeEnd[dce,e]],dx},
        If[(dx = v2[[1]] - v1[[1]]) == 0,v1[[2]],
           v1[[2]] + (v2[[2]] - v1[[2]]) (x - v1[[1]])/dx]];
    ord[x_][k1_,k2_] := k1[x] <= k2[x];
    bd = FaceBoundaries[dce,f];
    vl = Map[VertexCoord[dce,EdgeOrigin[dce,#1]]&,bd,{2}]; 
    tp = Apply[{Order[#1,#2],Order[#2,#3],
                If[SameQ[#1,#3],1,Order[LineSlope[{#2,#1}],
                                        LineSlope[{#2,#3}]]]}&,
               Map[Partition[#,3,1,2]&,vl],{2}];
    tp = tp /. {{-1,1,-1} -> start,{1,-1,-1} -> end,
                {1,1,_}  -> lower,{-1,-1,_} -> upper,
                {-1,1,1} -> split,{1,-1,1} -> merge};
    l = Sort[Flatten[Map[Thread,
               Thread[{vl,tp,Map[RotateRight,bd],bd}]],1]];
    sweep[dce,l,OrdTree[]]]




ClearAll[CartesianMesh]

CartesianMesh[{x1_,x2_},n_Integer] := 
  CartesianMesh[Range[x1,x2,(x2-x1)/(n-1)]]

CartesianMesh[x_List] := 
  Indexed[LineStrip[Range[Length[x]]],N[x]]

CartesianMesh[{x1_,x2_},{y1_,y2_},n_Integer] := 
  CartesianMesh[{x1,x2},{y1,y2},n,n]

CartesianMesh[{x1_,x2_},{y1_,y2_},n_Integer,m_Integer] := 
  CartesianMesh[Range[x1,x2,(x2-x1)/n],Range[y1,y2,(y2-y1)/m]]

CartesianMesh[x_List,y_List] := 
  Module[{n = Length[x],m = Length[y],t,v},
    t = Array[V,n m]; 
    v = Table[{x[[i]],y[[j]]},{j,1,m},{x,1,n}];
    Indexed[QuadPatch[n,t],N[Flatten[v,1]]]]




ClearAll[BilinearMesh]

BilinearMesh[{f1_,f2_},{g1_,g2_},{x1_,x2_},{y1_,y2_},n_Integer] := 
  BilinearMesh[{f1,f2},{g1,g2},{x1,x2},{y1,y2},n,n]

BilinearMesh[{exp1_,exp2_},{exp3_,exp4_},{x_,x1_,x2_},{y_,y1_,y2_},
              n_Integer,m_Integer] := 
  BilinearMesh[Table[exp1,{x,x1,x2,(x2 - x1)/n}],
               Table[exp2,{x,x1,x2,(x2 - x1)/n}],
               Table[exp3,{y,y1,y2,(y2 - y1)/m}],
               Table[exp4,{y,y1,y2,(y2 - y1)/m}]]

BilinearMesh[l1_List,l2_List,l3_List,l4_List] :=
  Module[{n = Length[l1],m = Length[l3],t,v},
    t = Array[V,n m];
    v = Table[((m - j) l1[[i]] + (j - 1) l2[[i]]) / (m - 1) +
              ((n - i) l3[[j]] + (i - 1) l4[[j]]) / (n - 1) +
              - ((n - i)(m - j) l1[[1]] + (i - 1)(m - j) l1[[n]]
                 + (n - i)(j - 1) l2[[1]] + (i - 1)(j - 1) l2[[n]]) /
                   ((n - 1)(m - 1)),
              {j,1,m},{i,1,n}];
    Indexed[QuadPatch[n,t],N[Flatten[v,1]]]]
