(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)





ClearAll[Lattice]  
Options[Lattice] = {Grid -> True};

Lattice[obj_,{x1_,x2_},{y1_,y2_},opts___?OptionQ] :=
  Module[{gr1 = obj /. {r_Raster :> RasterExpand[r],c_Chain :> Nothing},
          gr2 = obj /. {r_Raster :> Nothing,c_Chain :> ChainExpand[c]},
          xx1 = x1 - .5, xx2 = x2 + .5,
          yy1 = y1 - .5, yy2 = y2 + .5, 
          op = Flatten[{opts,Options[Lattice]}]},  
    Graphics[{{GrayLevel[1],Rectangle[{xx1,yy1},{xx2,yy2}]},
              gr1,
              If[Grid /. op,
                 {GrayLevel[.5],
                  Table[Line[{{xx1,yy},{xx2,yy}}],{yy,yy1,yy2}],
                  Table[Line[{{xx,yy1},{xx,yy2}}],{xx,xx1,xx2}]},
                 Nothing],
              PointSize[.02],Thickness[.005],gr2},
             Select[op,FreeQ[#,Grid]&],
             Frame -> True,
             FrameTicks -> {Range[x1,x2],Range[y1,y2]},
             PlotRange -> {{x1 - .75,x2 + .75},{y1 - .75,y2 + .75}},
             AspectRatio -> Automatic]]






ClearAll[RasterExpand]

RasterExpand[Raster[x_,m_]] :=
  MapIndexed[
    Which[#1 == 0,Nothing,
          #1 == 1,Rectangle[x + #2 - 1.5,x + #2 - .5],
          0 < #1 < 1,{GrayLevel[1 - #1],
                      Rectangle[x + #2 - 1.5,x + #2 - .5]},
          -1 <= #1 < 0,{RGBColor[1,1 + #1,1 + #1],
                        Rectangle[x + #2 - 1.5,x + #2 - .5]},
          True,{RGBColor[0,0,1],
                        Rectangle[x + #2 - 1.5,x + #2 - .5]}]&,
           m,{2}]




ClearAll[Origin,Pixels,InRangeQ,GetPixel,SetPixel]
Unprotect[Range];

Origin[r_Raster] := r[[1]]

Pixels[r_Raster] := r[[2]]

Range[r_Raster] := 
  Thread[{Origin[r],Origin[r] + Dimensions[Pixels[r]] - {1,1}}]

InRangeQ[r_Raster,{x_,y_}] :=
  Apply[And,Thread[0 <= {x,y} - Origin[r] < Dimensions[Pixels[r]]]]
  
GetPixel[r_Raster,{x_,y_},d_:0] := 
  If[InRangeQ[r,{x,y}],Extract[Pixels[r],{x,y} - Origin[r] + 1],d]

SetPixel[r_Raster,{x_,y_},p_] := 
  If[InRangeQ[r,{x,y}],
     Raster[Origin[r],ReplacePart[Pixels[r],p,{x,y} - Origin[r] + 1]],r]

Protect[Range];




ClearAll[Square,Diamond]
Unprotect[Disk];

Square[n_] := 
  Raster[{-n,-n},Table[1,{2 n + 1},{2 n + 1}]]

Diamond[n_] := 
  Raster[{-n,-n},Table[If[Abs[i] + Abs[j] <= n,1,0],{i,-n,n},{j,-n,n}]]

Disk[n_] := 
  Raster[{-n,-n},Table[If[i^2 + j^2 <= n^2,1,0],{i,-n,n},{j,-n,n}]]

Protect[Disk];



ClearAll[ClipRaster,TrimRaster]

ClipRaster[r_Raster,{{x1_,x2_},{y1_,y2_}}] :=
  Module[{ori = Origin[r],rg = Range[r],cx1,cx2,cy1,cy2,
          pxs = Table[0,{x2 - x1 + 1},{y2 - y1 + 1}]},
    cx1 = Max[x1,rg[[1,1]]]; cx2 = Min[x2,rg[[1,2]]];
    cy1 = Max[y1,rg[[2,1]]]; cy2 = Min[y2,rg[[2,2]]];
    If[And[cx1 <= cx2,cy1 <= cy2],
       pxs[[Range[cx1,cx2] - x1 + 1,
            Range[cy1,cy2] - y1 + 1]] =
         Take[Pixels[r],{cx1,cx2} - ori[[1]] + 1,
                        {cy1,cy2} - ori[[2]] + 1];
       Raster[{x1,y1},pxs]]]

TrimRaster[r_Raster] := 
  ClipRaster[r,Origin[r] + 
                Map[{Min[#],Max[#]}&,
                     Thread[Position[Pixels[r],_?Positive]]] - 1]




ClearAll[TranslateRaster,RotateRaster,ReflectRaster]

TranslateRaster[r_Raster,v_] := Raster[Origin[r] + v,Pixels[r]]

RotateRaster[r_Raster,CCW] := 
  Raster[Origin[r],Reverse[Thread[Pixels[r]]]]

RotateRaster[r_Raster,CW] := 
  Raster[Origin[r],Thread[Reverse[Pixels[r]]]]

ReflectRaster[r_Raster,X] := 
  Raster[Origin[r],Reverse[Pixels[r]]]

ReflectRaster[r_Raster,Y] := 
  Raster[Origin[r],Map[Reverse,Pixels[r]]]  
  
ReflectRaster[r_Raster,XY] := 
  Raster[Origin[r],Reverse[Map[Reverse,Pixels[r]]]]




ClearAll[RasterUnion,RasterIntersection,RasterComplement]
SetAttributes[{RasterUnion,RasterIntersection},{Flat,OneIdentity}]

RasterUnion[r1_Raster,r2_Raster] :=
  Module[{rg1 = Range[r1],rg2 = Range[r2],rg,cl1,cl2},
    rg = Map[{Min[#[[1]]],Max[#[[2]]]}&,
             Transpose[{rg1,rg2},{3,1,2}]];
    cl1 = ClipRaster[r1,rg]; cl2 = ClipRaster[r2,rg];
    Raster[Origin[cl1],MapThread[Max,{Pixels[cl1],Pixels[cl2]},2]]]

RasterIntersection[r1_Raster,r2_Raster] := 
  Module[{rg1 = Range[r1],rg2 = Range[r2],rg,cl1,cl2},
    rg = Map[{Max[#[[1]]],Min[#[[2]]]}&,
             Transpose[{rg1,rg2},{3,1,2}]];
    If[And[rg[[1,1]] <= rg[[1,2]],rg[[2,1]] <= rg[[2,2]]],
       cl1 = ClipRaster[r1,rg]; cl2 = ClipRaster[r2,rg];
       Raster[Origin[cl1],MapThread[Min,{Pixels[cl1],Pixels[cl2]},2]]]]

RasterComplement[r1_Raster,r2_Raster] := 
  Module[{cl2 = ClipRaster[r2,Range[r1]]},
    Raster[Origin[r1],MapThread[Max[0,#1 - #2]&,
                                {Pixels[r1],Pixels[cl2]},2]]]




ClearAll[RasterConvolve]

RasterConvolve[r_Raster,m:(_?MatrixQ|_Raster),d_:0] := 
  Module[{r1 = r,rg = Range[r],mat,dim,ngbds,val,x1,x2,y1,y2},
    If[MatchQ[m,_?MatrixQ],
       (dim = Reverse[Dimensions[m]];
        mat = Thread[Reverse[m]]),
       (dim = Dimensions[Pixels[m]];
        mat = Reverse[Map[Reverse,Pixels[m]]])];
    ngbds = Partition[Pixels[r],dim,{1,1},{Ceiling[dim/2]},d];
    x1 = rg[[1,1]]; x2 = rg[[1,2]]; y1 = rg[[2,1]]; y2 =rg[[2,2]];
    Do[val = (mat ngbds[[x - x1 + 1,y - y1 + 1]]) /. List -> Plus;
       If[val != GetPixel[r,{x,y}],r1 = SetPixel[r1,{x,y},val]],
       {y,y1,y2},{x,x1,x2}]; r1]




ClearAll[RasterApply]

RasterApply[f_,r_Raster,l:(_List|_Raster):{{0,0}},d_:0] := 
  Module[{r1 = r,rg = Range[r],pos,val},
    If[MatchQ[l,_List],pos = l,
       pos = Map[(# + Origin[l] - 1)&,
                 Position[Pixels[l],_?Positive]];
       pos = Split[pos,(#1[[1]] == #2[[1]])&]];
    Do[val = f[Map[GetPixel[r,{x,y} + #,d]&,pos,{-2}]];
       If[val != GetPixel[r,{x,y}],r1 = SetPixel[r1,{x,y},val]],
       {y,rg[[2,1]],rg[[2,2]]},{x,rg[[1,1]],rg[[1,2]]}]; r1]
       



ClearAll[RasterInverse,RasterThreshold]

RasterInverse[r_Raster] := RasterApply[(1 - #[[1]])&,r]

RasterThreshold[r_Raster,t_:0] := RasterApply[If[#[[1]] <= t,0,1]&,r]




ClearAll[RasterDilate,RasterErode,RasterInverse]

RasterDilate[r_Raster,mask_Raster:Square[1]] := RasterApply[Max,r,mask]

RasterErode[r_Raster,mask_Raster:Square[1]] := RasterApply[Min,r,mask,1]




ClearAll[FourEdges,EightEdges]

FourEdges[r_Raster] := 
  RasterApply[If[(Max[#] != #[[2,2]]),1,0]&,r,Square[1]]

EightEdges[r_Raster] := 
  RasterApply[If[(Max[#] != #[[2,2]]),1,0]&,r,Diamond[1]]




ClearAll[FourConnectedQ,EightConnectedQ,FourComponent,EightComponent]

FourConnectedQ[r_Raster] := 
  Module[{x = Position[Pixels[r],_?Positive,2,1]},
    Or[EmptyQ[x],SameQ[r,FourComponent[r,Origin[r] + x[[1]] - 1]]]]

EightConnectedQ[r_Raster] :=
  Module[{x = Position[Pixels[r],_?Positive,2,1]},
    Or[EmptyQ[x],SameQ[r,EightComponent[r,Origin[r] + x[[1]] - 1]]]]

FourComponent[r_Raster,x_] :=
  Module[{r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],comp,val},
    comp[x0_] :=
      If[And[GetPixel[r0,x0] == 0,(val = GetPixel[r,x0]) > 0],
         r0 = SetPixel[r0,x0,val];
         comp[x0 + {1,0}]; comp[x0 + {0,1}];
         comp[x0 + {-1,0}]; comp[x0 + {0,-1}]];
    comp[x]; r0]

EightComponent[r_Raster,x_] :=
  Module[{r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],comp,val},
    comp[x0_] :=
      If[And[GetPixel[r0,x0] == 0,(val = GetPixel[r,x0]) > 0],
         r0 = SetPixel[r0,x0,val];
         comp[x0 + {1,0}]; comp[x0 + {1,1}];
         comp[x0 + {0,1}]; comp[x0 + {-1,1}];
         comp[x0 + {-1,0}]; comp[x0 + {-1,-1}];
         comp[x0 + {0,-1}]; comp[x0 + {1,-1}]];
    comp[x]; r0]




ClearAll[FourFill,EightFill]

FourFill[r_Raster,x_] :=
  Module[{r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],fill,x1},
    fill[x0_] :=
      If[GetPixel[r0,x0,1] == 0,
         r0 = SetPixel[r0,x0,1];
         If[GetPixel[r,x1 = x0 + {1,0},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {0,1},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {-1,0},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {0,-1},1] == 0,fill[x1]]];
    If[GetPixel[r,x,1] == 0,fill[x]]; r0]

EightFill[r_Raster,x_] :=
  Module[{r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],fill,x1},
    fill[x0_] :=
      If[GetPixel[r0,x0,1] == 0,
         r0 = SetPixel[r0,x0,1];
         If[GetPixel[r,x1 = x0 + {1,0},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {1,1},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {0,1},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {-1,1},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {-1,0},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {-1,-1},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {0,-1},1] == 0,fill[x1]];
         If[GetPixel[r,x1 = x0 + {1,-1},1] == 0,fill[x1]]];
    If[GetPixel[r,x,1] == 0,fill[x]]; r0]




ClearAll[SimpleFourPathQ,SimpleEightPathQ,
         SimpleFourLoopQ,SimpleEightLoopQ]

SimpleFourPathQ[r_Raster] := 
  Module[{x = Position[Pixels[r],_?Positive,2,1],
          r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],check,val},
    check[x0_] :=
      If[And[GetPixel[r0,x0] == 0,(val = GetPixel[r,x0]) > 0],
         If[Count[{GetPixel[r,x0 + {1,0}],GetPixel[r,x0 + {1,1}],
                   GetPixel[r,x0 + {0,1}],GetPixel[r,x0 + {-1,1}],
                   GetPixel[r,x0 + {-1,0}],GetPixel[r,x0 + {-1,-1}],
                   GetPixel[r,x0 + {0,-1}],GetPixel[r,x0 + {1,-1}]},
                  _?Positive] > 2,False,
            r0 = SetPixel[r0,x0,val];
            And[check[x0 + {1,0}],check[x0 + {0,1}],
                check[x0 + {-1,0}],check[x0 + {0,-1}]]],True];
     And[Not[EmptyQ[x]],check[Origin[r] + x[[1]] - 1],SameQ[r,r0]]]

SimpleHeightPathQ[r_Raster] := 
  Module[{x = Position[Pixels[r],_?Positive,2,1],
          r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],check,val},
    check[x0_] :=
      If[And[GetPixel[r0,x0] == 0,(val = GetPixel[r,x0]) > 0],
         If[Count[{GetPixel[r,x0 + {1,0}],GetPixel[r,x0 + {1,1}],
                   GetPixel[r,x0 + {0,1}],GetPixel[r,x0 + {-1,1}],
                   GetPixel[r,x0 + {-1,0}],GetPixel[r,x0 + {-1,-1}],
                   GetPixel[r,x0 + {0,-1}],GetPixel[r,x0 + {1,-1}]},
                  _?Positive] > 2,False,
            r0 = SetPixel[r0,x0,val];
            And[check[x0 + {1,0}],check[x0 + {1,1}],
                check[x0 + {0,1}],check[x0 + {-1,1}],
                check[x0 + {-1,0}],check[x0 + {-1,-1}],
                check[x0 + {0,-1}],check[x0 + {1,-1}]]],True];
     And[Not[EmptyQ[x]],check[Origin[r] + x[[1]] - 1],SameQ[r,r0]]]

SimpleFourLoopQ[r_Raster] := 
  Module[{x = Position[Pixels[r],_?Positive,2,1],
          r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],check,val},
    check[x0_] :=
      If[And[GetPixel[r0,x0] == 0,(val = GetPixel[r,x0]) > 0],
         If[Count[{GetPixel[r,x0 + {1,0}],GetPixel[r,x0 + {1,1}],
                   GetPixel[r,x0 + {0,1}],GetPixel[r,x0 + {-1,1}],
                   GetPixel[r,x0 + {-1,0}],GetPixel[r,x0 + {-1,-1}],
                   GetPixel[r,x0 + {0,-1}],GetPixel[r,x0 + {1,-1}]},
                  _?Positive] != 2,False,
            r0 = SetPixel[r0,x0,val];
            And[check[x0 + {1,0}],check[x0 + {0,1}],
                check[x0 + {-1,0}],check[x0 + {0,-1}]]],True];
     And[Not[EmptyQ[x]],check[Origin[r] + x[[1]] - 1],SameQ[r,r0]]]

SimpleHeightLoopQ[r_Raster] := 
  Module[{x = Position[Pixels[r],_?Positive,2,1],
          r0 = Raster[Origin[r],Map[0&,Pixels[r],{2}]],check,val},
    check[x0_] :=
      If[And[GetPixel[r0,x0] == 0,(val = GetPixel[r,x0]) > 0],
         If[Count[{GetPixel[r,x0 + {1,0}],GetPixel[r,x0 + {1,1}],
                   GetPixel[r,x0 + {0,1}],GetPixel[r,x0 + {-1,1}],
                   GetPixel[r,x0 + {-1,0}],GetPixel[r,x0 + {-1,-1}],
                   GetPixel[r,x0 + {0,-1}],GetPixel[r,x0 + {1,-1}]},
                  _?Positive] != 2,False,
            r0 = SetPixel[r0,x0,val];
            And[check[x0 + {1,0}],check[x0 + {1,1}],
                check[x0 + {0,1}],check[x0 + {-1,1}],
                check[x0 + {-1,0}],check[x0 + {-1,-1}],
                check[x0 + {0,-1}],check[x0 + {1,-1}]]],True];
     And[Not[EmptyQ[x]],check[Origin[r] + x[[1]] - 1],SameQ[r,r0]]]






ClearAll[Chain,ChainSteps,ChainDirections,ChainExpand]

ChainSteps = {{1,0},{1,1},{0,1},{-1,1},{-1,0},{-1,-1},{0,-1},{1,-1}};
ChainDirections = {{3,2,1},{4,8,0},{6,7,8}};

ChainExpand[Chain[x_,v_,c_]] :=
  Module[{chainrest},
    chainrest[xx_,vv_,cc_] :=
      If[EmptyQ[cc],{},
         If[ListQ[First[cc]],
            {chainrest[xx,vv,First[cc]],
             chainrest[xx,vv,Rest[cc]]},
            Module[{nxx,nvv},
              nvv = Mod[vv + First[cc],8];
              nxx = xx + ChainSteps[[nvv + 1]];
              {Line[{xx,nxx}],Point[nxx],
               chainrest[nxx,nvv,Rest[cc]]}]]];
    Flatten[{Point[x],chainrest[x,v,c]}]]




ClearAll[StartDirection,ChainCode]

Origin[c_Chain] := c[[1]]

StartDirection[c_Chain] := c[[2]]

ChainCode[c_Chain] := c[[3]]




ClearAll[FourChainQ,EightChainQ,SimpleChainQ]

FourChainQ[x_] := 
  MatchQ[x,Chain[{_,_},v_?EvenQ /; 0 <= v <= 7,
                 c_List /; Length[Union[Flatten[c],Range[0,7,2]]] == 4]]

EightChainQ[x_] := 
  MatchQ[x,Chain[{_,_},v_Integer /; 0 <= v <= 7,
                 c_List /; Length[Union[Flatten[c],Range[0,7]]] == 8]]

SimpleChainQ[x_] := And[EightChainQ[x],Depth[ChainCode[x]] == 2]




ClearAll[ToFourChain,ToEightChain,ToRaster]

ToFourChain[r_Raster,x_] := Null

ToEightChain[r_Raster,x_] := Null

ToRaster[c_Chain] := 
  Module[{makecoord,coord,c1,y,w,t,x1,x2,y1,y2,rst},
    makecoord[x_,v_,code_] :=
      If[Not[EmptyQ[code]],
         Switch[c1 = code[[1]],
           _Integer,
             w = Mod[v + c1,8]; y = x + ChainSteps[[w + 1]];
             AppendTo[coord,y]; makecoord[y,w,Rest[code]],
           _List,makecoord[x,v,c1]; makecoord[x,v,Rest[code]]]];
    coord = {Origin[c]};
    makecoord[Origin[c],StartDirection[c],ChainCode[c]];
    t = Thread[coord]; x1 = Min[t[[1]]]; x2 = Max[t[[1]]];
                       y1 = Min[t[[2]]]; y2 = Max[t[[2]]];
    rst = Raster[{x1,y1},Table[0,{x2 - x1 + 1},{y2 - y1 + 1}]];
    Scan[If[GetPixel[rst,#] == 0,rst = SetPixel[rst,#,1]]&,coord]; rst]




ClearAll[TranslateChain,RotateChain,FeflectChain]

TranslateChain[c_Chain,v_] := 
  Chain[Origin[c] + v,StartDirection[c],ChainCode[c]]

RotateChain[c_Chain,CCW] := 
  Chain[Origin[c],Mod[StartDirection[c] + 2,8],ChainCode[c]]

RotateChain[c_Chain,CW] := 
  Chain[Origin[c],Mod[StartDirection[c] - 2,8],ChainCode[c]]

ReflectChain[c_Chain,X] := 
  Chain[Origin[c],Mod[4 - StartDirection[c],8],Mod[- ChainCode[c],8]]  

ReflectChain[c_Chain,Y] := 
  Chain[Origin[c],Mod[- StartDirection[c],8],Mod[- ChainCode[c],8]]  

ReflectChain[c_Chain,XY] := 
  Chain[Origin[c],Mod[4 + StartDirection[c],8],ChainCode[c]]  




ClearAll[SimplePathQ,SimplePathQ]

SimplePathQ[c_Chain,x_] := Null

SimpleLoopQ[c_Chain,x_] := Null
